"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var enzyme_1 = require("enzyme");
var Notie_1 = require("../Notie");
jest.useFakeTimers();
describe('<Notie />', function () {
    var provider;
    beforeEach(function () {
        provider = enzyme_1.mount(React.createElement(Notie_1.Notie, null));
    });
    afterEach(function () {
        if (provider) {
            provider.unmount();
            provider = null;
        }
    });
    test('initial render', function () {
        expect(provider).toMatchSnapshot();
    });
    test('success message', function () {
        if (!provider)
            return;
        provider.instance().showSuccess('Success!');
        provider.update();
        expect(provider).toMatchSnapshot();
        expect(provider.find(Notie_1.NotieContainer).prop('level')).toBe(Notie_1.NotieLevel.SUCCESS);
        jest.runTimersToTime(Notie_1.DEFAULT_TIMEOUT + 100);
        provider.update();
        expect(provider).toMatchSnapshot();
    });
    test('warn message', function () {
        if (!provider)
            return;
        provider.instance().showWarn('Warn!');
        provider.update();
        expect(provider).toMatchSnapshot();
        expect(provider.find(Notie_1.NotieContainer).prop('level')).toBe(Notie_1.NotieLevel.WARN);
        jest.runTimersToTime(Notie_1.DEFAULT_TIMEOUT + 100);
        provider.update();
        expect(provider).toMatchSnapshot();
    });
    test('Error message', function () {
        if (!provider)
            return;
        provider.instance().showError('Error!');
        provider.update();
        expect(provider).toMatchSnapshot();
        expect(provider.find(Notie_1.NotieContainer).prop('level')).toBe(Notie_1.NotieLevel.ERROR);
        jest.runTimersToTime(Notie_1.DEFAULT_TIMEOUT + 100);
        provider.update();
        expect(provider).toMatchSnapshot();
    });
    test('info message', function () {
        if (!provider)
            return;
        provider.instance().showInfo('Info!');
        provider.update();
        expect(provider).toMatchSnapshot();
        expect(provider.find(Notie_1.NotieContainer).prop('level')).toBe(Notie_1.NotieLevel.INFO);
        jest.runTimersToTime(Notie_1.DEFAULT_TIMEOUT + 100);
        provider.update();
        expect(provider).toMatchSnapshot();
    });
    // test.skip('consecutive calls', () => {
    //     const instance = provider.instance();
    //     instance.info('Info!');
    //     provider.update();
    //     expect(provider.find(components.NotieContainer).prop('level')).toBe('SUCCESS');
    //     expect(provider.find(components.NotieContainer).prop('active')).toBe(true);
    //     expect(provider).toMatchSnapshot();
    //     jest.runTimersToTime(2000);
    //     provider.update();
    //     instance.error('Error!');
    //     /*
    //         Must be triggered manually since `transitionend` event
    //         is not being trigged when using `dispatchEvent` on root
    //         element.
    //     */
    //     instance.transitionendCallback();
    //     expect(instance.transitionendCallback).toBe(null);
    //     provider.update();
    //     expect(provider.find('.react-notie-level--error').length).toBe(1);
    //     expect(provider.find('.react-notie--active').length).toBe(1);
    //     expect(provider).toMatchSnapshot();
    // });
    // test.skip('cleanup on unmount', () => {
    //     const instance = provider.instance();
    //     actions.notieInfo('Info!');
    //     actions.notieInfo('Info!');
    //     jest.runTimersToTime(2000);
    //     provider.update();
    //     provider.unmount();
    //     expect(instance.transitionendCallback).toBe(null);
    // });
    // test('dismiss click', () => {
    //     actions.notieInfo('Info!');
    //     provider.update();
    //     expect(provider.find(components.NotieContainer).prop('level')).toBe('INFO');
    //     expect(provider.find(components.NotieContainer).prop('active')).toBe(true);
    //     expect(provider).toMatchSnapshot();
    //     provider.find(components.NotieContainer).simulate('click');
    //     provider.update();
    //     expect(provider.find(components.NotieContainer).prop('active')).toBe(false);
    //     expect(provider).toMatchSnapshot();
    // });
    // describe('confirm', () => {
    //     test('initial render', () => {
    //         actions.notieConfirm('Are you sure?');
    //         provider.update();
    //         expect(provider.find(components.NotieContainer).prop('level')).toBe('CONFIRM');
    //         expect(provider.find(components.NotieContainer).prop('active')).toBe(true);
    //         expect(provider).toMatchSnapshot();
    //     });
    //     test.skip('click yes', (done) => {
    //         const instance = provider.instance();
    //         const promise = instance.confirm('Are you sure?');
    //         provider.update();
    //         provider.find('.react-notie-choice--yes').simulate('click');
    //         instance.transitionendCallback();
    //         expect(instance.transitionendCallback).toBe(null);
    //         provider.update();
    //         promise.then(() => {
    //             expect(provider).toMatchSnapshot();
    //             expect(provider.find(components.NotieContainer).prop('active')).toBe(false);
    //             done();
    //         });
    //     });
    //     test.skip('click no', (done) => {
    //         const instance = provider.instance();
    //         const promise = instance.confirm('Are you sure?');
    //         provider.update();
    //         provider.find('.react-notie-choice--no').simulate('click');
    //         instance.transitionendCallback();
    //         expect(instance.transitionendCallback).toBe(null);
    //         provider.update();
    //         promise.catch(() => {
    //             expect(provider).toMatchSnapshot();
    //             expect(provider.find(components.NotieContainer).prop('active')).toBe(false);
    //             done();
    //         });
    //     });
    //     test.skip('no consecutive calls', () => {
    //         const instance = provider.instance();
    //         instance.confirm('Are you sure?');
    //         provider.update();
    //         expect(provider.find('.react-notie-level--confirm').length).toBe(1);
    //         expect(provider).toMatchSnapshot();
    //         instance.info('Info!');
    //         provider.update();
    //         expect(provider.find('.react-notie-level--confirm').length).toBe(1);
    //         expect(provider).toMatchSnapshot();
    //     });
    //     test.skip('Custom button text', () => {
    //         const instance = provider.instance();
    //         instance.confirm('Are you sure?', {
    //             yesBtnText: 'Hell Yeah!',
    //             noBtnText: 'Fuck NO!'
    //         });
    //         expect(provider).toMatchSnapshot();
    //     });
    // });
});
